﻿using System;
using System.Collections.Generic;
using System.Linq;
using FindingAndActivatingInterfaceImplementations.Generators;

namespace FindingAndActivatingInterfaceImplementations
{
    class Program
    {
        static void Main(string[] args)
        {
            Program p = new Program();
            
            List<IGenerator> generators = p.GetAllGenerators();
            generators.ForEach(g => g.Generate("Hi from a generator."));
        }

        private List<IGenerator> GetAllGenerators()
        {
            List<IGenerator> generators = new List<IGenerator>();
            var iGenerator = typeof(IGenerator);
            var generatorsTypes = AppDomain.CurrentDomain.GetAssemblies() 
                .SelectMany(assembly => assembly.GetTypes())
                .Where(type => iGenerator.IsAssignableFrom(type) && type.IsClass);

            foreach (var generator in generatorsTypes)
            {
                generators.Add(Activator.CreateInstance(generator) as IGenerator);
            }
            return generators;
        }
    }
}
